/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   design.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_DESIGN_H
#define UHDM_DESIGN_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class design : public BaseClass {
  public:
    // Implicit constructor used to initialize all members,
    // comment: design();
    virtual ~design() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual const std::string& VpiFile() const final;

    virtual bool VpiFile(const std::string& data) final;

    virtual unsigned int VpiLineNo() const final { return vpiLineNo_; }

    virtual bool VpiLineNo(unsigned int data) final { vpiLineNo_ = data; return true;}

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    const std::string& VpiName() const;

    bool VpiName(const std::string& data);

    unsigned int VpiType() const final { return vpiDesign; }

    VectorOfpackage* AllPackages() const { return allPackages_; }

    bool AllPackages(VectorOfpackage* data) { allPackages_ = data; return true;}

    VectorOfclass_defn* AllClasses() const { return allClasses_; }

    bool AllClasses(VectorOfclass_defn* data) { allClasses_ = data; return true;}

    VectorOfinterface* AllInterfaces() const { return allInterfaces_; }

    bool AllInterfaces(VectorOfinterface* data) { allInterfaces_ = data; return true;}

    VectorOfudp_defn* AllUdps() const { return allUdps_; }

    bool AllUdps(VectorOfudp_defn* data) { allUdps_ = data; return true;}

    VectorOfprogram* AllPrograms() const { return allPrograms_; }

    bool AllPrograms(VectorOfprogram* data) { allPrograms_ = data; return true;}

    VectorOfmodule* AllModules() const { return allModules_; }

    bool AllModules(VectorOfmodule* data) { allModules_ = data; return true;}

    VectorOfmodule* TopModules() const { return topModules_; }

    bool TopModules(VectorOfmodule* data) { topModules_ = data; return true;}

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmdesign; }   
  private:
    
    BaseClass* vpiParent_;

    unsigned int uhdmParentType_;

    SymbolFactory::ID vpiFile_;

    unsigned int vpiLineNo_;

    unsigned int uhdmId_;

    SymbolFactory::ID vpiName_;

    VectorOfpackage* allPackages_;

    VectorOfclass_defn* allClasses_;

    VectorOfinterface* allInterfaces_;

    VectorOfudp_defn* allUdps_;

    VectorOfprogram* allPrograms_;

    VectorOfmodule* allModules_;

    VectorOfmodule* topModules_;

  };

  
  class designFactory {
  friend Serializer;
  public:
  design* Make() {
    design* obj = new design();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<design*> objects_;
  };
  
  
  class VectorOfdesignFactory {
  friend Serializer;
  public:
  std::vector<design*>* Make() {
    std::vector<design*>* obj = new std::vector<design*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<design*>*> objects_;
  };

};

#endif

