/*
 Do not modify, auto-generated by model_gen.tcl

 Copyright 2019 Alain Dargelas

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 */

/*
 * File:   parameter.h
 * Author:
 *
 * Created on December 14, 2019, 10:03 PM
 */

#ifndef UHDM_PARAMETER_H
#define UHDM_PARAMETER_H

#include "SymbolFactory.h"
#include "BaseClass.h"
#include "containers.h"
#include "uhdm.h"

namespace UHDM {

  class parameter : public simple_expr {
  public:
    // Implicit constructor used to initialize all members,
    // comment: parameter();
    virtual ~parameter() final {}
    
    virtual const BaseClass* VpiParent() const final { return vpiParent_; }

    virtual bool VpiParent(BaseClass* data) final { vpiParent_ = data; if (data) uhdmParentType_ = data->UhdmType(); return true;}

    virtual unsigned int UhdmParentType() const final { return uhdmParentType_; }

    virtual bool UhdmParentType(unsigned int data) final { uhdmParentType_ = data; return true;}

    virtual const std::string& VpiFile() const final;

    virtual bool VpiFile(const std::string& data) final;

    virtual unsigned int VpiLineNo() const final { return vpiLineNo_; }

    virtual bool VpiLineNo(unsigned int data) final { vpiLineNo_ = data; return true;}

    unsigned int UhdmId() const { return uhdmId_; }

    bool UhdmId(unsigned int data) { uhdmId_ = data; return true;}

    int VpiConstType() const { return vpiConstType_; }

    bool VpiConstType(int data) { vpiConstType_ = data; return true;}

    bool VpiSigned() const { return vpiSigned_; }

    bool VpiSigned(bool data) { vpiSigned_ = data; return true;}

    bool VpiLocalParam() const { return vpiLocalParam_; }

    bool VpiLocalParam(bool data) { vpiLocalParam_ = data; return true;}

    const std::string& VpiName() const;

    bool VpiName(const std::string& data);

    const std::string& VpiFullName() const;

    bool VpiFullName(const std::string& data);

    const expr* Expr() const { return expr_; }

    bool Expr(expr* data) { expr_ = data; return true;}

    const expr* Left_range() const { return left_range_; }

    bool Left_range(expr* data) { left_range_ = data; return true;}

    const expr* Right_range() const { return right_range_; }

    bool Right_range(expr* data) { right_range_ = data; return true;}

    unsigned int VpiType() const final { return vpiParameter; }

   virtual  UHDM_OBJECT_TYPE UhdmType() const final { return uhdmparameter; }   
  private:
    
    BaseClass* vpiParent_;

    unsigned int uhdmParentType_;

    SymbolFactory::ID vpiFile_;

    unsigned int vpiLineNo_;

    unsigned int uhdmId_;

    int vpiConstType_;

    bool vpiSigned_;

    bool vpiLocalParam_;

    SymbolFactory::ID vpiName_;

    SymbolFactory::ID vpiFullName_;

    expr* expr_;

    expr* left_range_;

    expr* right_range_;

  };

  
  class parameterFactory {
  friend Serializer;
  public:
  parameter* Make() {
    parameter* obj = new parameter();
    objects_.push_back(obj);
    return obj;
  }
  private:
    std::vector<parameter*> objects_;
  };
  
  
  class VectorOfparameterFactory {
  friend Serializer;
  public:
  std::vector<parameter*>* Make() {
    std::vector<parameter*>* obj = new std::vector<parameter*>();
    objects_.push_back(obj);
    return obj;
  }
  private:
  std::vector<std::vector<parameter*>*> objects_;
  };

};

#endif

